package filter;

import java.util.HashMap;

import utils.Counter;

public class CREWAActionCounter extends Filter
{
	int totalActions = 0;
	private HashMap<String, Counter> actionCounter = new HashMap<String, Counter>();


	public CREWAActionCounter()
	{
		actionCounter.clear();
	}


	@Override
	public void computeInfo(String content)
	{
		if (!content.endsWith("EOF"))
		{
			if (content.indexOf("]") > -1)
			{
				content = content.substring(content.indexOf("]") + 1);
			}
			else if (content.indexOf("-") > -1)
			{
				content = content.substring(content.lastIndexOf("-") + 1);
			}
	
			content = content.trim();
			// filter action names
			content = content.replaceAll("\"[^\"]*\"", "...");
			content = content.replaceAll("at Coordinates.*", "");
			Counter c = null;
			if ((c = actionCounter.get(content)) == null)
			{
				actionCounter.put(content, c = new Counter());
			}
			totalActions++;
			c.inc();
		}
	}


	@Override
	public String getInfo()
	{
		info += "ActionCounter:" + newLine;
		info += "// " + totalActions + " actions in total" + newLine;
		for (String action : actionCounter.keySet())
		{
			info += actionCounter.get(action).getValue() + " times - " + action + newLine;
		}
		return info;
	}
}
