package filter;

import java.util.HashMap;

import utils.Counter;

public class CREWACheckActions extends Filter
{

	private HashMap<String, Counter> allActions = new HashMap<String, Counter>();


	public CREWACheckActions()
	{
		allActions.clear();

		// CREWA
		// AndroidCursor.java
		allActions.put("Public Interrupt-Message displayed", new Counter());
		allActions.put("Private Interrupt-Message sent", new Counter());

		// CREWAWindow.java
		allActions.put("Option: Cancel", new Counter());
		allActions.put("Association-edge from_changed to association edge", new Counter());
		allActions.put("Inheritance-edge from_changed to association edge", new Counter());
		allActions.put("Aggregation-edge from_changed to association edge", new Counter());
		allActions.put("Association-edge from_changed to inheritance edge", new Counter());
		allActions.put("Inheritance-edge from_changed to inheritance edge", new Counter());
		allActions.put("Aggregation-edge from_changed to inheritance edge", new Counter());
		allActions.put("Association-edge from_changed to aggregation edge", new Counter());
		allActions.put("Inheritance-edge from_changed to aggregation edge", new Counter());
		allActions.put("Aggregation-edge from_changed to aggregation edge", new Counter());
		allActions.put("Association-edge from_changed direction", new Counter());
		allActions.put("Inheritance-edge from_changed direction", new Counter());
		allActions.put("Aggregation-edge from_changed direction", new Counter());
		allActions.put("Aggregation-edge from_created", new Counter());
		allActions.put("Association-edge from_created", new Counter());
		allActions.put("Inheritance-edge from_created", new Counter());
		allActions.put("Reset use-case by class-delete dialog opened for", new Counter());
		allActions.put("Clear history by class-delete dialog opened for", new Counter());
		allActions.put("Delete component dialog opened for", new Counter());
		allActions.put("New class_created", new Counter());
		allActions.put("Remove edge menu opened for edge from", new Counter());
		allActions.put("New class_created (Scanner)", new Counter());
		allActions.put("New class_created (Scanner)", new Counter());
		allActions.put("Insert menu canceled", new Counter());
		allActions.put("Source component for edge deselected:", new Counter());
		allActions.put("OptionPanel opened", new Counter());
		allActions.put("OptionPanel hidden", new Counter());
		allActions.put("Start use-case", new Counter());
		allActions.put("Pause use-case", new Counter());
		allActions.put("Switch to use-case-mode", new Counter());
		allActions.put("Switch to UML-mode", new Counter());
		allActions.put("Step back", new Counter());
		allActions.put("Step forward", new Counter());

		// InfoPanel.java
		allActions.put("Option: Clear history by deleting class", new Counter());
		allActions.put("Option: Reset use-case by deleting class", new Counter());
		allActions.put("Option: Clear history by releasing class", new Counter());
		allActions.put("Option: Reset use-case by releasing class", new Counter());
		allActions.put("Option: Reset", new Counter());
		allActions.put("Option: Delete Component", new Counter());
		allActions.put("Option: Delete association-edge from", new Counter());
		allActions.put("Option: Delete aggregation-edge from", new Counter());
		allActions.put("Option: Delete inheritance-edge from", new Counter());
		allActions.put("Option: Edit Component", new Counter());

		// OptionPanel.java
		allActions.put("Switch to UML-mode", new Counter());
		allActions.put("Switch to use-case-mode", new Counter());
		allActions.put("Start use-case", new Counter());
		allActions.put("Pause use-case", new Counter());
		allActions.put("Reset-use-case-history confirmation menu opened", new Counter());
		allActions.put("Back to start", new Counter());
		allActions.put("Step forward", new Counter());
		allActions.put("Jump to end", new Counter());

		// AndroidClient.java
		allActions.put("Lockmessage received from Component", new Counter());
		allActions.put("Component_deleted", new Counter());
		allActions.put("Lockmessage received from Component", new Counter());
		allActions.put("Lock received for Component", new Counter());
		allActions.put("Lock released for Component", new Counter());
		allActions.put("Lock released for Component", new Counter());

		// CRCComponent.java
		allActions.put("Responsibility_added to class", new Counter());
		allActions.put("Collaborator_added to class", new Counter());
		allActions.put("Responsibility_deleted in class", new Counter());
		allActions.put("Collaborator_deleted in class", new Counter());
		allActions.put("Responsibility_moved from", new Counter());
		allActions.put("Collaborator_moved from", new Counter());
		allActions.put("Class_unlocked", new Counter());
		allActions.put("Responsibility_changed to", new Counter());
		allActions.put("Collaborator_changed to", new Counter());
		allActions.put("Class name changed from_to", new Counter());
		allActions.put("AddLoopEdge menu opened for class", new Counter());
		allActions.put("Source component for edge selected:", new Counter());
		allActions.put("Target Component for Edge selected:_AddEdge menu opened", new Counter());
		allActions.put("Component-is-part-of-active-use-case release dialog opened", new Counter());
		allActions.put("Component-is-part-of-history release dialog opened", new Counter());
		allActions.put("Class_lost owner", new Counter());
		allActions.put("Drag ended for class", new Counter());
		allActions.put("Drag started for class_(UML-mode)", new Counter());
		allActions.put("Edit Component", new Counter());
		allActions.put("Drag ended for class", new Counter());
		allActions.put("Class_marked as unfinished", new Counter());
		allActions.put("Unfinished-mark from class_removed", new Counter());
		allActions.put("Drag started for class_(Use-Case)", new Counter());
		allActions.put("Drag ended for class", new Counter());
		allActions.put("Class_got new owner", new Counter());
		allActions.put("Class_responsibilities fulfilled", new Counter());
		allActions.put("Task delegated to", new Counter());

		// CREWdroid
		// CanvasClass.java
		allActions.put("Server Ip set to", new Counter());
		allActions.put("Main Menu started", new Counter());
		allActions.put("Returned to Main Menu", new Counter());
		allActions.put("Change Mode triggered", new Counter());
		allActions.put("OptionPanel triggered", new Counter());
		allActions.put("Play/Pause-Mode change triggered", new Counter());
		allActions.put("Mark Class as unfinished triggered", new Counter());
		allActions.put("Logfile sent", new Counter());
		allActions.put("Interrupted-Message received", new Counter());

		// CreateClass.java
		allActions.put("Responsibility_moved to end of list", new Counter());
		allActions.put("Responsibilities_changed positions", new Counter());
		allActions.put("Collaborator_moved to end of list", new Counter());
		allActions.put("Collaborators_changed positions", new Counter());
		allActions.put("Class_sent to server", new Counter());
		allActions.put("Responsibilities_and Collaborators", new Counter());
		allActions.put("Collaborators_moved to new class", new Counter());
		allActions.put("Responsibilities_moved to new class", new Counter());
		allActions.put("Duplicate of class_sent to server", new Counter());
		allActions.put("New Card_opened", new Counter());

		// EditClass.java
		allActions.put("Lockmessage received from Component", new Counter());
		allActions.put("Lockmessage received from Component", new Counter());
		allActions.put("Card-List opened", new Counter());
		allActions.put("Class_selected for editing", new Counter());
		allActions.put("Class_deleted", new Counter());

		// MainMenu.java
		allActions.put("Server Ip set to", new Counter());
		allActions.put("Returned to Main Menu", new Counter());
		allActions.put("Main Menu started", new Counter());

		// NameList.java
		allActions.put("Name list opened", new Counter());
		allActions.put("User_voted", new Counter());

		// RequirementsText.java
		allActions.put("Requirements-Text opened", new Counter());
	}


	@Override
	public void computeInfo(String content)
	{
		if (!content.endsWith("EOF"))
		{
			String[] parts;
			for (String action : allActions.keySet())
			{
				parts = action.split("_");
				if (parts.length == 2 && !parts[0].isEmpty() && !parts[1].isEmpty())
				{
					if (content.contains(parts[0]) && content.contains(parts[1]))
					{
						allActions.get(action).inc();
					}
				}
				else
				{
					if (content.contains(action))
					{
						allActions.get(action).inc();
					}
				}
			}
		}
	}


	@Override
	public String getInfo()
	{
		int counter = 0;
		info += "CheckActions:" + newLine;
		info += "// Following actions were not used by this group" + newLine;
		
		for (String action : allActions.keySet())
		{
			// info += allActions.get(action).getValue()+" times - "+action+newLine;
			if (allActions.get(action).getValue() == 0)
			{
				info += "- " + action + newLine;
				counter++;
			}
		}
		
		info += "// In total " + counter + " out of " + allActions.size() + " were not used." + newLine;

		return info;
	}

}
