package filter;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

public class Parser
{

	private static String newLine = System.getProperties().getProperty("line.separator");
	private File inputFile;
	private File outputFile;
	private String basedir = "";
	private LinkedList<Filter> filters = new LinkedList<Filter>();


	public Parser(String basedir)
	{
		this.basedir = basedir;
	}


	public void addFilter(Filter filter)
	{
		filters.add(filter);
	}


	public void parse(String inputFilename) throws IOException
	{
		inputFile = new File(basedir + inputFilename);
		BufferedReader in = new BufferedReader(new FileReader(inputFile));
		String content = "";
		
		while ((content = in.readLine()) != null)
		{

			if (!content.startsWith("#"))
			{
				// compute filter for each line
				for (Filter filter : filters)
				{
					filter.computeInfo(content);
				}
			}
		}
		
		in.close();
	}


	public void print(String outputFilename) throws IOException
	{
		outputFile = new File(basedir + outputFilename);
		BufferedWriter out = new BufferedWriter(new FileWriter(outputFile));
		// get info of all filters
		for (Filter filter : filters)
		{
			out.write(filter.getInfo());
			out.write("==================================================================" + newLine);
			out.flush();
		}
		out.close();
	}

}
