package filter;

import utils.Activity;

public class Timer extends Filter
{
	private long firstTime = 0L;
	private long lastTime = 0L;


	@Override
	public void computeInfo(String content)
	{
		Activity activity = new Activity(content);

		// remember first timestamp and get last timestamp
		if (firstTime == 0L)
		{
			firstTime = activity.getTimestamp();
		}

		lastTime = activity.getTimestamp();
	}


	@Override
	public String getInfo()
	{
		info += "Timer:" + newLine;
		info += "Duration of experiment: ";

		// compute duration and return formatted information
		long diff = lastTime - firstTime;
		long secondsInMillis = 1000;
		long minutesInMillis = secondsInMillis * 60;
		long hoursInMillis = minutesInMillis * 60;
		info += (diff / hoursInMillis) + " hours ";
		diff %= hoursInMillis;
		info += (diff / minutesInMillis) + " minutes ";
		diff %= minutesInMillis;
		info += (diff / secondsInMillis) + " seconds " + newLine;

		return info;
	}

}
