package main;
import utils.ActivityCategory;

import java.awt.*;
import java.util.Properties;

public class LFAProperties extends Properties
{
	private static final long serialVersionUID = -1596346056023630799L;

	static Properties properties;
	
	public static final ActivityCategory IDLE_GROUP = new ActivityCategory("idle", Color.WHITE, Integer.MIN_VALUE);
	public static final ActivityCategory MISC_GROUP = new ActivityCategory("misc", Color.LIGHT_GRAY, 0);
	
	public static enum GroupedActivitiesMode { FAIR, IDLE } 
	public static final String SEPARATOR = ";";
    public static final String FILE_EXTENSION = ".log";

	// Visualization
	public static enum GroupedActivitiesDrawType { LINES, RECTS, BARS }
	public static enum TimeSpansDrawType { BARS, BARS2 }
	
	public static enum ActivityLines { OFF, ABSOLUTE, PER_MINUTE, PER_MINUTE_SQRT };
	public static GroupedActivitiesDrawType gaDrawType = GroupedActivitiesDrawType.LINES;
	
	public static TimeSpansDrawType tsDrawType = TimeSpansDrawType.BARS2;
	public static ActivityLines activityLines = ActivityLines.OFF;
	public static GroupedActivitiesMode gaMode = GroupedActivitiesMode.FAIR;
	
	public static final int VIS_WIDTH = 1920;
	public static final int VIS_HEIGHT = 155; // Must be a multiple of the number of categories displayed
	public static final int VIS_GAP_X = 10;
	public static final int VIS_GAP_Y = 30;
	public static final int VIS_INITIAL_SQUASH = 3250;
	public static final float VIS_ZOOM_FACTOR = 1.125f;
	public static final Color VIS_BACKGROUND_COLOR = new Color(255, 255, 255, 255);
	
	public static final int GA_FILTER = 0;
	public static final int GA_ACTIVITY_LINES_THICKNESS = 4;
	public static final int GA_MINUTE_STEPS = 10;
	
	public static final float TS_VERTICAL_STRETCH = 5.0f;
	public static final boolean TS_SHOW_DESCRIPTION = true;
	public static final int TS_FONT_GAP = 4;
	public static final int TS_GRID_LINES = 10;
	public static final int TS_TIME_SPAN_LENGTH = 30000;
	public static final int TS_NUMBER_STEPS = 4; // 0 = no numbers
    public static final int TS_SAVE_FRAME = 2; // number of additional white pixels around the saved image

	
	private LFAProperties()
	{
//		this.defaults = new Properties();
//
//		// "idle" or "fair"
//		defaults.setProperty("filter.groupedActivities.mode", "fair");
//		defaults.setProperty("separator", ";");
//		
//		defaults.setProperty("vis.width", "1920");
//		defaults.setProperty("vis.height", "150");
//		defaults.setProperty("vis.gapX", "40");
//		defaults.setProperty("vis.gapY", "30");
//		
//		defaults.setProperty("vis.groupedActivities.drawType", "lines");
	}
	
	
	public void loadProperties()
	{
		
	}


	public static Properties getProperties()
	{
		if (properties == null)
		{
			properties = new LFAProperties();
		}
		
		return properties;
	}
}
