package utils;

import java.util.ArrayList;

import static main.LFAProperties.*;

public class Activity implements Comparable<Activity>
{
	protected long timestamp;
	protected String description;
	protected ArrayList<String> fields;

	protected String originalMessage;


	public Activity(String logMessage)
	{
		this.originalMessage = logMessage;
		this.fields = new ArrayList<String>();

		String[] splitMessage = logMessage.split(SEPARATOR);

		this.timestamp = Long.parseLong(splitMessage[0].trim());
		this.description = splitMessage[1].trim();

		for (int i = 2; i < splitMessage.length; i++)
		{
			String field = splitMessage[i].trim();
			fields.add(field);
		}
	}


	public Activity(Activity activityToCopy)
	{
		this.timestamp = activityToCopy.timestamp;
		this.description = activityToCopy.description;
		this.fields = activityToCopy.fields;
	}


	public long getTimestamp()
	{
		return timestamp;
	}


	public String getDescription()
	{
		return description;
	}


	public String getOriginalMessage()
	{
		return originalMessage;
	}


	public ArrayList<String> getFields()
	{
		return fields;
	}


	public void shiftTimestamp(long shift)
	{
		this.timestamp += shift;
	}


	public Activity clone()
	{
		return new Activity(this);
	}


	@Override
	public int compareTo(Activity activity)
	{
		if (this.timestamp < activity.getTimestamp())
			return -1;

		if (this.timestamp > activity.getTimestamp())
			return 1;
		return 0;
	}


	@Override
	public String toString()
	{
		String output = String.valueOf(timestamp) + SEPARATOR + description + SEPARATOR;

		for (int i = 0; i < fields.size(); i++)
		{
			String field = fields.get(i);

			if (i < fields.size() - 1)
			{
				output += field + SEPARATOR;
			}
			else
			{
				output += field;
			}
		}

		return output;
		// return originalMessage;
	}
}