/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.overlay;

import org.jetbrains.annotations.NotNull;

import java.awt.*;

/**
 * Created by Peter on 28.10.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public interface OverlayElementCustomDrawable {

    /**
     * Sets the location and size of the overlayComponent.
     */
    public void updateLocationAndSize(@NotNull OverlayComponent component);

    /**
     * Runs any neccessary drawing
     */
    public void paintComponent(@NotNull OverlayComponent component, @NotNull Graphics g);


}
