/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg;

/**
 * Created with IntelliJ IDEA.
 * User: Peter
 * Date: 23.11.13
 * Time: 14:58
 */

import com.intellij.codeInsight.daemon.LineMarkerInfo;
import com.intellij.codeInsight.daemon.LineMarkerProvider;
import com.intellij.openapi.application.ApplicationManager;
import com.intellij.psi.PsiElement;
import com.intellij.psi.javadoc.PsiDocComment;
import com.intellij.psi.javadoc.PsiDocTag;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import plg.sketchlinks.LocalLinkAnchor;
import plg.sketchlinks.SketchlinkManager;

import java.util.Collection;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Peter
 * Date: 23.11.13
 * Time: 12:02
 */
public class SvgLineMarkerProvider implements LineMarkerProvider {

    @Nullable
    @Override
    public LineMarkerInfo getLineMarkerInfo(final @NotNull PsiElement element) {
        if (element instanceof PsiDocComment) {
            for (@NotNull PsiDocTag docTag : SketchlinkManager.TOOLS.getSketchlinkTags((PsiDocComment) element)) {
                //add docTag to SketchlinkManager, ignore the result
                @Nullable LocalLinkAnchor anchor = SketchlinkManager.getAnchorOf(docTag);
            }
        }
        /*
            Misuse the LineMarker Provider to mark all visited elements whether the algorithm can find an sketchlink for them or not
         */
/*
        Document document = PsiDocumentManager.getInstance(element.getProject()).getDocument(element.getContainingFile());
        if (document == null) {
            System.out.println("Can't mark in svgLinemarkerprovider, document null");
            return null;
        }
        Editor[] editors = EditorFactory.getInstance().getEditors(document,element.getProject());
        final Editor editor = editors[0];
        final HighlighterTargetArea area = HighlighterTargetArea.EXACT_RANGE;

        JBColor color = new JBColor(new Color(198, 255, 179), new Color(210, 255, 224));
        JBColor colorfalse = new JBColor(new Color(255, 70, 9),new Color(255, 33, 75));


        final TextAttributes attributes = new TextAttributes(null, color, null, null, Font.BOLD);
        if (!SketchlinkManager.getInstance().hasSketchlink(element)) {
            if (!(element instanceof PsiDocComment && slToolBox.checkCommentContainsSketchlink((PsiDocComment) element)))
                attributes.setBackgroundColor(colorfalse);
        }
        ApplicationManager.getApplication().invokeLater(new Runnable() {
            @Override
            public void run() {
                synchronized (highlighterList) {
                    highlighterList.add(editor.getMarkupModel().addRangeHighlighter(element.getTextRange().getStartOffset(),
                            element.getTextRange().getEndOffset(),
                            0,
                            attributes,
                            area));
                }
            }
        });
*/
        return null;
    }

    /**
     * Sobald eine Datei das erste (?) mal im Texteditor geöffnet oder zu ihr gewechselt wird, wird diese Methode mit ALLEN PsiElementen aufgerufen.
     * Hier vielleicht bei kaltem Cache reinhängen um alle nötigen Links vom Server zu verlangen?
     *
     * @param elements
     * @param result
     */
    @Override
    public void collectSlowLineMarkers(@NotNull final List<PsiElement> elements, @NotNull Collection<LineMarkerInfo> result) {
        ApplicationManager.getApplication().runReadAction(new Runnable() {
            @Override
            public void run() {

                for (PsiElement element : elements) {
                    if (element instanceof PsiDocComment) {
                        for (@NotNull PsiDocTag docTag : SketchlinkManager.TOOLS.getSketchlinkTags((PsiDocComment) element)) {
                            @Nullable LocalLinkAnchor anchor = SketchlinkManager.getAnchorOf(docTag);
                        }
                    }
                }
            }
        });
    }
}
