/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.actions.quicktesting;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.project.Project;
import plg.sketchlinks.LinkAnchor;
import plg.sketchlinks.SketchlinkManager;
import plg.ui.preview.svgwrapper.SVGPanelExt;
import plg.websocket.slWebsocketManager;

/**
 * Created by Peter on 09.11.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public class OpenSketchInWebViewAction extends AnAction {

    @Override
    public void update(AnActionEvent e) {
        Project project = e.getProject();
        SVGPanelExt panelExt = e.getData(SVGPanelExt.DATA_KEY);
        if (project == null || panelExt == null)
            return;
        boolean connected = slWebsocketManager.getInstance(project).isConnected();
        e.getPresentation().setEnabled(connected);
    }

    public void actionPerformed(AnActionEvent e) {
        Project project = e.getProject();
        SVGPanelExt panelExt = e.getData(SVGPanelExt.DATA_KEY);
        if (project == null || panelExt == null)
            return;
        String sketchID = panelExt.getDiagramEx().getSketchID();
        LinkAnchor knownAnchor = SketchlinkManager.getInstance(project).getKnownAnchor(sketchID);
        if (knownAnchor == null)
            return;
        knownAnchor.navigateTo();
    }
}
