/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.actions.quicktesting;

import com.intellij.javadoc.JavadocConfiguration;
import com.intellij.javadoc.JavadocGenerationManager;
import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.application.PathManager;
import org.jetbrains.annotations.Contract;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * Created by Peter on 03.02.14.
 */
public class RegisterJavaDocTaglet extends AnAction {

    public void actionPerformed(@NotNull AnActionEvent e) {
        // TODO: insert action logic here
        @NotNull SketchlinkTaglet taglet = new SketchlinkTaglet();

        //String location = PathManager.getHomePathFor(SketchlinkTaglet.class);
        //System.out.println(taglet.getName()+" "+location+" "+PathManager.getJarPathForClass(SketchlinkTaglet.class));
        //System.out.println(PathManager.getPluginsPath());
        //System.out.println(PathManager.getPluginTempPath());

        //JavadocManager manager = JavadocManager.SERVICE.getInstance(e.getProject());
        //JavadocGenerationManager manager = e.getProject().getComponent(JavadocGenerationManager.class);
        if (e.getProject() == null)
            return;
        JavadocGenerationManager manager = JavadocGenerationManager.getInstance(e.getProject());
        if (manager == null) {
            //System.out.println("RegisterJavaDocTaglet bailing out");
            return;
        }
        final JavadocConfiguration config = manager.getConfiguration();

        if (config.OTHER_OPTIONS == null) {
            config.OTHER_OPTIONS = "-taglet " + SketchlinkTaglet.class.getName(); //NON-NLS NON-NLS
        } else {
            if (config.OTHER_OPTIONS.contains(SketchlinkTaglet.class.getName())) {
                return; //already setup
            }
            config.OTHER_OPTIONS += " -taglet " + SketchlinkTaglet.class.getName(); //NON-NLS
        }
        config.OTHER_OPTIONS += " -tagletpath " + PathManager.getJarPathForClass(SketchlinkTaglet.class); //NON-NLS


    }

    @Nullable
    @Contract("null -> null")
    public String removeMySetup(@Nullable String options) {
        if (options == null)
            return null;
        if (!options.contains(SketchlinkTaglet.class.getName()))
            return options;
        //-taglet[\w\d\s\-":/\\\.]+myexampletaglet(\.class)?"?
        //problem: above deletes everything between the first -taglet an
        return options.replaceAll("-taglet[ ]+" + SketchlinkTaglet.class.getName(), ""); //NON-NLS

    }

    public boolean alreadySetup(@NotNull String options) {
        return options.contains(SketchlinkTaglet.class.getName());
    }
}
