/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.actions.quicktesting;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.project.Project;
import plg.websocket.commands.builder.GetSketchesRequestBuilder;
import plg.websocket.slWebsocketManager;

/**
 * Created by Peter on 22.10.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public class ShowAllSketchesFromServer extends AnAction {

    @Override
    public void update(AnActionEvent e) {
        Project project = e.getProject();
        if (project == null)
            return;
        boolean connected = slWebsocketManager.getInstance(project).isConnected();
        e.getPresentation().setEnabled(connected);
    }

    public void actionPerformed(AnActionEvent e) {
        Project project = e.getProject();
        if (project == null)
            return;
        new GetSketchesRequestBuilder(false).send(project, null);
//        System.out.println("Unlinked sketches requested");
    }
}
