/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.actions.quicktesting;

import com.sun.javadoc.Tag;
import com.sun.tools.doclets.Taglet;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Map;

/**
 * Created by Peter on 03.02.14.
 */

public class SketchlinkTaglet implements Taglet {
    public static void register(@NotNull Map<String, SketchlinkTaglet> tagletMap) {
        @NotNull SketchlinkTaglet taglet = new SketchlinkTaglet();
        Taglet t = tagletMap.get(taglet.getName());
        if (t != null) {
            tagletMap.remove(taglet.getName());
        }
        tagletMap.put(taglet.getName(), taglet);
    }

    @Override
    public boolean inField() {
        return true;
    }

    @Override
    public boolean inConstructor() {
        return true;
    }

    @Override
    public boolean inMethod() {
        return true;
    }

    @Override
    public boolean inOverview() {
        return true;
    }

    @Override
    public boolean inPackage() {
        return true;
    }

    @Override
    public boolean inType() {
        return true;
    }

    @Override
    public boolean isInlineTag() {
        return false;
    }

    @NotNull
    @Override
    public String getName() {
        return "sketchlink";
    }

    @NotNull
    @Override
    public String toString(@NotNull Tag tag) {
//        return "<DT><B>Sketchlink</B><DD>"
//                +"<table cellpadding=2 cellspacing=0><tr><td bgcolor=\"yellow\">"
//                + tag.text()
//                +"</td></tr></table></DD>\n";
        return "\n<DT><B>Sketchlink:</B>"
                + "<DD><table cellpadding=2 cellspacing=0>"
                + "<tr><td>There probably exist some Sketches for this Method, using ID:"
                + tag.text()
                + "<br/></td></tr>"
                + "<tr><td>"
                + "You may view them on a <a href=\"https://frodo.uni-trier.de/trac/sketchlink/wiki\">default Server</a> or <a href=\"https://www.google.de/#q=sketchlink+"
                + tag.text()
                + "\">Google for it</a>"
                + "</td></tr></table></DD>";
    }

    @Nullable
    @Override
    public String toString(@NotNull Tag[] tags) {
        if (tags.length == 0)
            return null;
        if (tags.length == 1)
            return toString(tags[0]);

        @NotNull String result = "\n<DT><B>Sketchlink: (multiple)</B><DD>";
        result += "<table cellpadding=2 cellspacing=0><tr><td bgcolor=\"yellow\">";
        result += "<tr><td>There probably exist some Sketches for this Method, several IDs possible:"
                + "<br/></td></tr>" + "<tr><td>";
        for (int i = 0; i < tags.length; i++) {
            if (i > 0) {
                result += "</td></tr><tr><td>";
            }
            result += "<B>" + (i + 1) + ".</B> " + "<a href=\"https://frodo.uni-trier.de/trac/sketchlink/wiki\">Visit default Server</a> or <a href=\"https://www.google.de/#q=sketchlink+"
                    + tags[i].text()
                    + "\">Google for it</a>";
        }
        return result + "</td></tr></table></DD>\n";
    }
//    public static void register(Map tagletMap) {
//        SketchlinkTaglet tag = new SketchlinkTaglet();
//        Taglet t = (Taglet) tagletMap.get(tag.getName());
//        if (t != null) {
//            tagletMap.remove(tag.getName());
//        }
//        tagletMap.put(tag.getName(), tag);
//
//    }
}
