/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
package plg.sketchlinks;

import com.intellij.openapi.project.Project;
import org.jetbrains.annotations.NotNull;

import javax.swing.*;

/**
 * Created by Peter on 22.03.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public interface LinkAnchor {

    @NotNull
    public Project getProject();

    /**
     * The ID of a Sketchlink Anchor
     */
    @NotNull
    public String getAnchorId();

    void setAnchorId(@NotNull String id);

    @NotNull
    public String getDescription();

    @NotNull
    public AnchorTypes getAnchorType();

    /**
     * @return the matching Icon for the anchor type
     */
    @NotNull
    public ImageIcon getImageIcon();

    /**
     * Try to navigate to this Anchor, either by searching and opening this inside the IDE, for local Anchors,
     * or opening this inside a connected (or local) Sketchlink-Viewer inside a Browser
     */
    public void navigateTo();

//    /**
//     * Set the state of the anchor.
//     *
//     * @param state
//     */
//    public void setAnchorState(AnchorState state);
//    public AnchorState getAnchorState();

    public enum AnchorTypes {
        Code_Anchor, SVG_Anchor, SVG_Rectangle_Anchor, URL_Anchor
    }

//    /**
//     * Different states an anchor can be in.
//     * changed: The anchor changed, e.g., its meta-information compared to the server values
//     * unchanged: the anchor is unchanged to its server values
//     * created: the anchor was recently (and locally) created
//     * deleted: the anchor was locally deleted
//     */
//    public enum AnchorState {
//        changed, unchanged, created, deleted
//    }


}
