/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.sketchlinks;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * Created by Peter on 06.10.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public interface MetadataOwner<T extends SketchMetadata> {

    /**
     * Gets the metadata of this anchor.
     * Should be the metadata of this anchor on the server
     */
    @Nullable
    T getMetadata();

    /**
     * Sets the metadata of this anchor.
     * Does not update its contents on the server.
     */
    void setMetadata(@NotNull T metadata);

}
