/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.sketchlinks;

import com.google.gson.GsonBuilder;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

/**
 * Created by Peter on 03.04.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public class SketchMetadataTypeC implements SketchMetadata {
    @Nullable
    private String parentID = null;
    @NotNull
    private String path = "";
    @NotNull
    private String targetType = "";
    @Nullable
    private String targetName = null;
    @NotNull
    private String projectName = "";


    @Override
    public boolean equals(@Nullable Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        @NotNull SketchMetadataTypeC that = (SketchMetadataTypeC) o;

        if (parentID != null ? !parentID.equals(that.parentID) : that.parentID != null) return false;
        if (path != null ? !path.equals(that.path) : that.path != null) return false;
        if (projectName != null ? !projectName.equals(that.projectName) : that.projectName != null) return false;
        if (targetName != null ? !targetName.equals(that.targetName) : that.targetName != null) return false;
        if (targetType != null ? !targetType.equals(that.targetType) : that.targetType != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = parentID != null ? parentID.hashCode() : 0;
        result = 31 * result + (path != null ? path.hashCode() : 0);
        result = 31 * result + (targetType != null ? targetType.hashCode() : 0);
        result = 31 * result + (targetName != null ? targetName.hashCode() : 0);
        result = 31 * result + (projectName != null ? projectName.hashCode() : 0);
        return result;
    }

    @NotNull
    public String getProjectName() {

        return projectName;
    }

    public void setProjectName(@NotNull String projectName) {
        this.projectName = projectName;
    }

    @Override
    public String toString() {
        return new GsonBuilder().serializeNulls().create().toJson(this, SketchMetadataTypeC.class);
    }

    @Nullable
    public String getParentID() {
        return parentID;
    }

    public void setParentID(@Nullable String parentID) {
        this.parentID = parentID;
    }

    @NotNull
    public String getPath() {
        return path;
    }

    public void setPath(@NotNull String path) {
        this.path = path;
    }

    @NotNull
    public String getTargetType() {
        return targetType;
    }

    public void setTargetType(@NotNull String targetType) {
        this.targetType = targetType;
    }

    @Nullable
    public String getTargetName() {
        return targetName;
    }

    public void setTargetName(@Nullable String targetName) {
        this.targetName = targetName;
    }

}
