/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.sketchlinks;


import com.intellij.psi.PsiElement;
import com.intellij.psi.PsiReference;
import com.intellij.psi.javadoc.JavadocTagInfo;
import com.intellij.psi.javadoc.PsiDocTagValue;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import plg.slApplicationState;

/**
 * Registers the @sketchlink tag to IntelliJ.
 */
public class SketchlinkTagInfoForIntelliJ implements JavadocTagInfo {


    @Override
    public String getName() {
        return slApplicationState.SKETCHLINK_TAGNAME;
    }

    @Override
    public boolean isInline() {
        return true;
    }

    @Override
    public boolean isValidInContext(PsiElement element) {
        return true;
    }

    @NotNull
    @Override
    public Object[] getPossibleValues(PsiElement context, PsiElement place, String prefix) {
        //System.out.println("SketlinkTaglet got asked for possible values "+context.getTextRange()+" "+place.getTextRange()+" "+prefix);
        return new Object[0];
    }

    /**
     * Checks the tag value for correctness.
     *
     * @param value Doc tag to check.
     * @return Returns null if correct, error message otherwise.
     */
    @Nullable
    @Override
    public String checkTagValue(@Nullable PsiDocTagValue value) {
        if (value == null) return "SketchlinkTagInfoForIntelliJ#checkTagValue: ID expected";
        //System.out.println("SketchlinkTagInfoForIntelliJ#checkTagCalue "+ value.getText());
        return null;
    }

    @Nullable
    @Override
    public PsiReference getReference(PsiDocTagValue value) {
        return null;
    }
}
