/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.ui.preview;

import org.jetbrains.annotations.NotNull;
import plg.sketchlinks.LinkAnchor;

/**
 * Created by Peter on 05.04.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public interface AvailableViews {

    @NotNull
    public String getDisplayName();

    public void setDisplayName(@NotNull String displayName);

    @NotNull
    public String getType();

    public void setType(@NotNull String type);

    @NotNull
    public String getIdentifier();

    public void setIdentifier(@NotNull String identifier);

    public boolean isWebview();

    public void addViewableArtifactID(@NotNull LinkAnchor anchor);

    public void removeViewableArtifactID(@NotNull LinkAnchor anchor);

    public boolean canShow(@NotNull LinkAnchor anchor);


    String getIpAddress();

    void setIpAddress(String ipAddress);
}
