/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.ui.sketchupload;

import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.project.Project;
import org.jetbrains.annotations.Nullable;
import plg.ui.preview.PreviewManager;

/**
 * Created by Peter on 27.10.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public class ShowUploadedSketchesAction extends AnAction {

    public void actionPerformed(AnActionEvent e) {
        @Nullable Project project = e.getProject();
        if (project == null)
            return;
        PreviewManager previewManager = PreviewManager.getInstance(project);
        previewManager.showUploadedSketches();
    }
}
