/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.websocket;

import com.google.gson.GsonBuilder;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.Nullable;

import java.util.UUID;

/**
 * Created by Peter on 03.04.2014.
 * Part of Sketchlink Plugin for IntelliJ
 */
public class CommandTopParameter {
    @Nullable
    public UUID id = null;
    @Nullable
    public String message = null;
    @Nullable
    @NonNls
    public String type = null;
    @Nullable
    public Payload data = null;

    public CommandTopParameter() {
        this.id = UUID.randomUUID();
    }

    public CommandTopParameter(@Nullable UUID uuid) {
        if (uuid != null) {
            this.id = uuid;
        } else {
            this.id = UUID.randomUUID();
        }
    }

    public boolean isValid() {
        return id != null && message != null && type != null && data != null;
    }

    @Override
    public String toString() {
        return new GsonBuilder().serializeNulls().create().toJson(this);
    }

}
