/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.websocket;


import com.intellij.openapi.actionSystem.AnAction;
import com.intellij.openapi.actionSystem.AnActionEvent;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.util.IconLoader;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import plg.slApplicationState;
import plg.slProjectComp;

import javax.swing.*;

/**
 * Created by Peter on 29.01.14.
 */
public class WebSocketConnectAction extends AnAction {
    private static final Icon offlineIcon = IconLoader.getIcon("/plg/ui/icons/sketchlink_offline.png", WebSocketConnectAction.class); //NON-NLS
    private static final Icon onlineIcon = IconLoader.getIcon("/plg/ui/icons/sketchlink_online.png", WebSocketConnectAction.class); //NON-NLS
    private static final Icon limitedIcon = IconLoader.getIcon("/plg/ui/icons/sketchlink_createMode.png", WebSocketConnectAction.class); //NON-NLS


    @Override
    public void update(@NotNull AnActionEvent e) {
        @Nullable Project project = e.getProject();
        if (project == null)
            return;
        if (slWebsocketManager.getInstance(project).isConnected()) {
            e.getPresentation().setIcon(slWebsocketManager.getInstance(project).isUpdateServerOnCreate() ? onlineIcon : limitedIcon);
            e.getPresentation().setText(slApplicationState.RESOURCE_BUNDLE.getString("disconnect.from.sketchlink.server"));
        } else {
            e.getPresentation().setIcon(offlineIcon);
            e.getPresentation().setText(slApplicationState.RESOURCE_BUNDLE.getString("connect.to.sketchlink.server"));
        }
    }


    public void actionPerformed(@NotNull AnActionEvent e) {
        @Nullable Project project = e.getProject();
        if (project == null)
            return;
        slProjectComp projectComp = slProjectComp.getInstance(project);
        projectComp.setConnectedToServer(!projectComp.isConnectedToServer());
//        slWebsocketManager.getInstance(project).toggleWebsocketConnection(false);
    }


}
