/*
 * Copyright (c) 2014. by Peter Schmitz (ptsmail01@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc.,
 *     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

package plg.websocket;

import com.intellij.openapi.project.Project;
import org.jetbrains.annotations.NotNull;

/**
 * Created by Peter on 22.02.14.
 */
public class slWebsocketManagerImpl extends slWebsocketManager {
    @NotNull
    private final ChannelManager myChannelManager;
    @NotNull
    private final CommandsManager myCommandsManager;


    public slWebsocketManagerImpl(@NotNull Project project) {
        super(project);
        this.myChannelManager = new ChannelManagerImpl(this);
        this.myCommandsManager = new CommandsManagerImpl(this);

    }


    @Override
    public boolean isConnected() {
        for (@NotNull SketchlinkChannel channel : getChannelManager().getAllChannels()) {
            if (channel.isOpen()) {
                return true;
            }
        }
        return false;
    }

    @NotNull
    @Override
    public ChannelManager getChannelManager() {
        return this.myChannelManager;
    }

    @NotNull
    @Override
    public CommandsManager getCommandsManager() {
        return this.myCommandsManager;
    }
}
